import java.util.Comparator;

public class Person implements Comparable<Person> {
	protected String name; // instance member field
	protected int age; // instance member field

	// default constructor
	public Person() {	
		this("", 0);
	}
	
	// constructor
	public Person(String name, int age) {
		super();
		this.name = name;
		this.age = age;
	}

	// getter & setter
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getAge() {
		return age;
	}

	public void setAge(int age) {
		this.age = age;
	}

	public void print() {
		System.out.println(this);
	}
	
	// Object toString() method overriding
	@Override
	public String toString() {
		return "Person [name=" + name + ", age=" + age + "]";
	}

	// Comparable interface compareTo() method overriding
	@Override
	public int compareTo(Person o) {
		return this.name.compareTo(o.name);
	}

	public static Comparator<Person> AgeComparator = new Comparator<Person>() {

		@Override
		public int compare(Person o1, Person o2) {
			return o1.age - o2.age; // ascending order
		}
		
	};
}
